﻿using System;
using System.IO;
using System.Net;
using System.Text;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Framework.Common;

namespace BDDFramework
{
    /// <summary>
    /// 
    /// </summary>
    public class AndroidFranklyDriver : FranklyDriver
    {
        public AndroidFranklyDriver(string url): base(url) 
        {

        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="query"></param>
        /// <param name="text"></param>
        public override void SetText(string query, string text)
        {
            JObject obj = new JObject();
            obj["query"] = query;
            JObject operation = new JObject();
            operation["method_name"] = "query";
            var arguments = new JArray();
            JObject editArgs = new JObject();
            editArgs["method_name"] = "setText";
            JArray editMethodArgs = new JArray();
            editMethodArgs.Add(text);
            editArgs["arguments"] = editMethodArgs;
            arguments.Add(editArgs);
            operation["arguments"] = arguments;
            obj["operation"] = operation;
            var json = obj.ToString();
            WebRequest req = WebRequest.Create(this.url + "/map");
            req.Method = "POST";
            var content = Encoding.UTF8.GetBytes(json);
            req.ContentLength = content.Length;
            req.ContentType = "application/json";
            var stream = req.GetRequestStream();
            stream.Write(content, 0, content.Length);

            var res = req.GetResponse();
            var outStream = res.GetResponseStream();
            var reader = new StreamReader(outStream);
            var response = reader.ReadToEnd();
            outStream.Close();

            /*
            JObject result = JObject.Parse(response);
            if (result["outcome"].Value<string>() != "SUCCESS")
            {
                throw new Exception(
                    "query operation failed because: " +
                    result["reason"] + "\n" +
                    result["details"]);
            }
            return (JArray)result["results"];
            */
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="query"></param>
        public override void Touch(string query)
        {
            // we need two requests for that
            // 1. query the button / element we want to touch, and get its coordinates
            // 2. execute a touch_coordinate action
            // need to wait for the first request to finish, before executing the second one
            JArray result = this.Find(query);
            // now execute a touch coordinate action
            JObject obj = new JObject();
            obj["command"] = "touch_coordinate";
            JArray args = new JArray();
            double x = result[0]["rect"]["center_x"].Value<double>();
            double y = result[0]["rect"]["center_y"].Value<double>();
            args.Add(x);
            args.Add(y);
            obj["arguments"] = args;
            var json = obj.ToString();
            WebRequest req = WebRequest.Create(this.url);
            req.Method = "POST";
            var content = Encoding.UTF8.GetBytes(json);
            req.ContentLength = content.Length;
            req.ContentType = "application/json";
            var stream = req.GetRequestStream();
            stream.Write(content, 0, content.Length);
        }

        public override void SendKeys(string query, string text)
        {
            throw new NotImplementedException();
        }
    }
}
