﻿using System;
using System.IO;
using System.Net;
using System.Text;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace Framework.Common
{
    /// <summary>
    /// 
    /// </summary>
    public abstract class FranklyDriver
    {
        protected string url = null;

        /// <summary>
        /// 
        /// </summary>
        /// <param name="url"></param>
        public FranklyDriver(string url)
        {
            this.url = url;
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="query"></param>
        /// <returns></returns>
        /// <summary>
        /// 
        /// </summary>
        /// <param name="query"></param>
        /// <returns></returns>
        public JArray Find(string query)
        {
            JObject obj = new JObject();
            obj["query"] = query;
            JObject operation = new JObject();
            operation["method_name"] = "query";
            var arguments = new JArray();
            /*
            foreach (var arg in args)
            {
                arguments.Add(arg);
            }
            */
            operation["arguments"] = arguments;
            obj["operation"] = operation;
            var json = obj.ToString();
            WebRequest req = WebRequest.Create(this.url + "/map");
            req.Method = "POST";
            var content = Encoding.UTF8.GetBytes(json);
            req.ContentLength = content.Length;
            req.ContentType = "application/json";
            var stream = req.GetRequestStream();
            stream.Write(content, 0, content.Length);

            var res = req.GetResponse();
            var outStream = res.GetResponseStream();
            var reader = new StreamReader(outStream);
            var response = reader.ReadToEnd();
            outStream.Close();

            JObject result = JObject.Parse(response);
            if (result["outcome"].Value<string>() != "SUCCESS")
            {
                throw new Exception(
                    "query operation failed because: " +
                    result["reason"] + "\n" +
                    result["details"]);
            }
            return (JArray)result["results"];
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="query"></param>
        /// <param name="text"></param>
        public abstract void SetText(string query, string text);

        /// <summary>
        /// 
        /// </summary>
        /// <param name="query"></param>
        public abstract void Touch(string query);

        /// <summary>
        /// 
        /// </summary>
        /// <param name="query"></param>
        /// <param name="text"></param>
        public abstract void SendKeys(string query, string text);
    }
}
