﻿using System;
using TechTalk.SpecFlow;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using BDDFramework;

namespace TODOAppTests.JS
{
    [Binding]
    public class AddingTasksSteps
    {
        [BeforeFeature]
        protected static void InitDriver()
        {
            FeatureContext.Current.Add("platformDriver", new TodoAppPlatformDriver());
        }

        [AfterFeature]
        protected static void CleanupDriver()
        {
            TodoAppPlatformDriver driver = (TodoAppPlatformDriver)FeatureContext.Current["platformDriver"];
            driver.Cleanup();
            FeatureContext.Current.Remove("platformDriver");
        }

        [Given(@"The TODO Application has loaded successfully")]
        public void GivenTheTODOApplicationHasLoadedSuccessfully()
        {
            TodoAppPlatformDriver driver = (TodoAppPlatformDriver)FeatureContext.Current["platformDriver"];
            driver.EnsureAppLoaded();
        }
        
        [Given(@"The task list is empty")]
        public void GivenTheTaskListIsEmpty()
        {
            TodoAppPlatformDriver driver = (TodoAppPlatformDriver)FeatureContext.Current["platformDriver"];
            driver.EnsureTaskListEmpty();
        }
        
        [When(@"I add a new task with the text '(.*)'")]
        public void WhenIAddANewTaskWithTheText(string text)
        {
            TodoAppPlatformDriver driver = (TodoAppPlatformDriver)FeatureContext.Current["platformDriver"];
            driver.AddNewTask(text);
        }
        
        [Then(@"The text of the last task in the list should be '(.*)'")]
        public void ThenTheTextOfTheLastTaskInTheListShouldBe(string text)
        {
            TodoAppPlatformDriver driver = (TodoAppPlatformDriver)FeatureContext.Current["platformDriver"];
            string actual = driver.GetTaskText(driver.GetTaskCount() - 1);
            Assert.AreEqual(text, actual);
        }
    }
}
